        program crntab

C Takes a dataset in Cornell condensed format and converts it to format
C used by TABLEFIT;  dimensioned for 5000 samples and 5000 species
        parameter (ninam=10,nnite=40,nc=80)
        parameter (nsmpmx=20000,nspmax=5000,nnrow=500)
        common/com1/tnam
        common/com2/lshort
        common/com3/lsamp

        integer iisp(nnite)
        real quant(nnite)
        character*1 a1(80),a2(80),blank1
        character*20 filein,fileou,blnk20
        character*30 fmt
        character*2 col70
        character*4 gen,sp
        character*8 lnam(ninam),blank8,lsamp(nsmpmx),tnam(nnrow,ninam)
        character*8 sh
        character*9 short,lshort(nspmax),blank9
        data blank8/'        '/
        data blank9/'         '/,blank1/' '/
        data blnk20/'                    '/

        print 2069,nsmpmx,nspmax
 2069 format(////1x,'Program CORNTABL, written by Mark Hill'/
     1    5x,'Oct 1992, revised Sep 2011, May 2015'//
     2    1x,'Converts Cornell Condensed format to TABLEFIT format'//
     3    1x,'Dimensioned for maximum',i6,' samples',i5,' species')
        call inout(7,9)
        read(7,1000,end=999) (a1(ic),ic=1,nc)
        write(*,1000) (a1(ic),ic=1,nc)
 1000 format(80a1)
        read(7,1000,end=999) (a2(ic),ic=1,nc)
        write(*,1000) (a1(ic),ic=1,nc)
        do 50 icc=1,20
                if(a2(icc).ne.blank1) goto 55
   50           continue
   55   write(fmt,3000) (a2(ic),ic=icc,30+icc-1)
 3000 format(30a1)
        print 2501, fmt
 2501 format(1x,a30)
        write(col70,3001) (a2(ic),ic=69,70)
 3001 format(2a1)
        nitem=0
        read(col70,3002,err=110) nitem
 3002 format(i2)
  110   continue
        read(7,*,err=111) nnitem
  111   continue
        read(7,fmt,err=998) isamp,iisp(1),quant(1)
        if (nitem.gt.0) then
          if(nnitem.ne.1) print 2000
 2000 format(/1x,'Beware - number of items seems to be',i4/
     1        1x,'yet first number on next card is    ',i4)
          nstart=2
          goto 190
          end if
        if (nitem.eq.0.and.nnitem.gt.1) then
          nstart=3
          nitem=nnitem
          goto 190
          end if
C In this case we are a bit lost, because we do not know how many
C items per line
        print 2001
 2001 format(/1x,'Number of couplets per line is taken to be 1'/
     1      1x,'If wrong, put desired number as card 3 of data'/
     2      1x,'Press <RETURN> to continue')
        read(*,*)

  190     rewind(7)
          if(nitem.ne.1) print 2002,nitem
 2002 format(/1x,'Number of couplets per line is',i3)
          do 195 istart=1,nstart
               read(7,*)
  195          continue

          nsp=0
          nsamp=0
          iisamp=0
          ierr=0
  200     read(7,fmt) isamp,(iisp(item),quant(item),item=1,nitem)
          write(*,fmt) isamp,(iisp(item),quant(item),item=1,nitem)
          if(isamp.eq.0) goto 290
          if(isamp.ne.iisamp) then
               irem=mod(isamp,10)
               if(irem.eq.0) print *,isamp
               if(isamp.ne.iisamp+1) then
                    print 2003,iisamp,isamp
 2003 format(1x,'*** BEWARE *** Non-sequential sample numbers',2i6)
                    ierr=ierr+1
                    if(ierr.lt.2) then
                         print 2056
 2056 format(/1x,'Press <RETURN> to continue')
                         read(*,*)
                         end if
                    end if
               iisamp=isamp
               nsamp=isamp
               end if
          do 210 item=1,nitem
               if(iisp(item).gt.nsp) nsp=iisp(item)
  210          continue
          if(nsp.gt.nspmax) then
               print 2004,nsp,nspmax
 2004 format(//1x,'*** ERROR ***  Species number',i6,'exceeds',i6/
     1         1x,'Program must be redimensioned and recompiled')
               call hold
               stop
               end if
          if(nsamp.gt.nsmpmx) then
               print 2005,nsamp,nsmpmx
 2005 format(//1x,'*** ERROR ***  Sample number',i6,'exceeds',i6/
     1         1x,'Program must be redimensioned and recompiled')
               call hold
               stop
               end if
          goto 200
  290     continue
          lin=0
  300     read(7,1010,end=390) (lnam(inam),inam=1,ninam)
 1010 format(10a8)
          lin=lin+1
          do 310 inam=1,ninam
               tnam(lin,inam)=lnam(inam)
  310          continue
          goto 300

  390     continue
          print 2007,nsp
 2007 format(/1x,'Highest species number in data matrix is',i6)
          print 2008,nsamp
 2008 format(/1x,'Highest sample number in data matrix is',i6)
          n1=(nsp+9)/10
          n2=(nsamp+9)/10
          if(n1+n2.gt.nnrow) then
               nnnn=(n1+n2)*ninam
               nsum=nsp+nsamp
               print 2009,nsum,nnnn
 2009 format(//1x,'*** ERROR *** Number of spp + samples is',i5,
     1     1x,'but cannot exceed',i5/1x,'Redimension and recompile')
               call hold
               stop
               end if
          if (lin.lt.n1) then
               print 2999
 2999 format(//1x,'*** Not enough species names ***')
               call hold
               stop
               end if
          if (lin.gt.n1+n2) then
C This is case where apparently too many names;  register sample names
C at the end
               if (mod(nsp,10).ne.0) then
                    if(tnam(n1,10).eq.blank8.and.tnam(n1+1,1).ne.blank8)
     1                   goto 400
                    end if
               ndiff=lin-n1-n2
               do 395 idiff=1,ndiff
                    do 393 inam=1,ninam
                         if (tnam(lin-idiff+1,inam).ne.blank8) goto 396
  393                    continue
  395               continue
C In this case the only problem is trailing blank lines
               goto 400
  396          continue
               do 397 i=n1+1,lin-n2-idiff+1
                    if(tnam(i,ninam).eq.blank8.and.tnam(i+1,1).ne.
     1                   blank8) then
                         n1=i
                         goto 400
                         end if
  397               continue
               n1=lin-n2-idiff+1
               end if
  400     continue
C We now write the names to the appropriate files
          isp=0
          do 410 i1=1,n1
               do 405 inam=1,ninam
                    isp=isp+1
                    sh=tnam(i1,inam)
                    read(sh,3010) gen,sp
 3010 format(2a4)
                    write(short,3011) gen,sp
 3011 format(a4,1x,a4)
                    if (short.eq.blank9) write(short,3012)
 3012 format('No Name  ')
                    lshort(isp)=short
  405               continue
  410          continue

          if (lin.lt.n1+n2) n2=lin-n1
          isamp=0
          do 420 i2=1,n2
               do 415 inam=1,ninam
                    isamp=isamp+1
                    sh=tnam(i2+n1,inam)
                    if(sh.eq.blank8) write(sh,3013)
                    lsamp(isamp)=sh
 3013 format('No Name ')
  415               continue
  420          continue
          rewind(7)

C lshort and lsamp now contain the lists of names

          do 495 istart=1,nstart
               read(7,*)
  495          continue

          iisamp=0
  500     read(7,fmt) isamp,(iisp(item),quant(item),item=1,nitem)
          if(isamp.eq.0) goto 999
          if(isamp.ne.iisamp) then
               if (iisamp.ne.0) write(9,2029)
 2029 format(1x)
               write(9,2030) lsamp(isamp)
               print 2031,lsamp(isamp)
               end if
 2030 format(a8)
 2031 format(1x,a8)
          iisamp=isamp
          do 550 item=1,nitem
               isp=iisp(item)
               if (isp.eq.0) goto 550
               short=lshort(isp)
               write(9,2032) short,quant(item)
 2032 format(1x,a9,2x,f6.1)
  550          continue
          goto 500

  998     continue
C This is the case where the card on line 4 does not seem to have right
C format, or format statement is wrong
          print 2039
 2039 format(//1x,'*** Error *** Format on card 2 has wrong syntax',
     1        /1x,'              or data on card 4 do not fit format')
          call hold
          stop

  999     write(9,2040)
 2040 format(1x)
          print 2042
 2042 format(//1x,'End of data')
          close(7)
          close(9)
          call hold
          stop
          end

      subroutine hold
C Asks for user input before exiting, to retain DOS window
      character*1 ch
      write(*,2000)
 2000 format(////'*** Program finished  ***'///
     1       'Press <RETURN> to exit'///
     2              '*************************')
      read(*,1000) ch
 1000 format(a1)
      return
      end

       subroutine inout(inunit,iout)
C opens inunit for input and iout for output
      character*20 filein,fileout,blank20/'                    '/
      write(*,2062)
 2062 format(//1x,'Enter name of input datafile in Cornell format'/
     1         1x,'     or press <RETURN> for default CORNELL.txt')
  100 continue
      read(*,1000) filein
 1000 format(a20)
      if(filein.eq.blank20) then
         open(unit=inunit,file='CORNELL.txt',status='old',err=123)
         goto 130
         end if
  122 continue
      open(unit=inunit,file=filein,status='old',err=123)
      goto 130
  123 continue
      write(*,2064)
 2064 format(/'  *** ERROR *** File does not exist'/
     1        ' Type another name')
      goto 100
  130 continue
      write(*,2077)
 2077 format(//1x,'Type name of output file (TABLEFIT format)'/
     1         1x,'     or press <RETURN> for default SAMP.txt')

  205 continue
      read(*,1000) fileout
      if(fileout.eq.blank20) then
         fileout='SAMP.txt'
         call filogood(fileout,iout)
         goto 220
         end if   
      open(unit=iout,file=fileout,status='new',err=210)
      goto 220
  210 continue
      write(*,2000) fileout
 2000 format(/'  *** ERROR *** File already exists'/
     1        ' Type another name, not ',a20)
      goto 205
 220  continue
      return
      end  

        subroutine filogood(fileout,iunit)
C Finds an output file name based on fileout and adding digits
        character*20 fileout,fileout1,fileout2
        character*1 f1(20),blank1/' '/,dot1/'.'/
        character*1 d(10)/'0','1','2','3','4','5','6','7','8','9'/
        character*1 t/'t'/,x/'x'/
        character*1 w(2)
        character*2 ww
        equivalence(f1,fileout1)
        equivalence(w,ww)
        fileout1=fileout
        fileout2=fileout
        if(f1(1).eq.blank1) f1(1)=t
        do k=1,99
           do i=1,14
              if(f1(i).eq.dot1.or.f1(i).eq.blank1) then
                 ii=i
                 goto 100
                 end if
              ii=14
              enddo
  100      continue
           open(unit=iunit,file=fileout,status='new',err=110)
           return
  110      continue
           if(k.lt.10) then
              f1(ii)=d(1)
              ii=ii+1
              f1(ii)=d(k+1)
              else
              write(ww,2000) k
 2000 format(i2)
              f1(ii)=w(1)
              ii=ii+1
              f1(ii)=w(2)
              end if
           ii=ii+1
           f1(ii)=dot1
           ii=ii+1
           f1(ii)=t
           ii=ii+1
           f1(ii)=x
           ii=ii+1
           f1(ii)=t
           do iii=ii+1,20
              f1(iii)=blank1
              enddo
           fileout=fileout1
           fileout1=fileout2
           enddo
        fileout=fileout2
        return
        end
