        program corn

        parameter (nitem=7,ndmax=5000)
        integer ispec(200)
        real quant(200)
        character*9 dict1(ndmax),short,blank9
        character*8 sname,samp(ndmax),dic(ndmax),blank8
        character*4 word1,word2
        character*18 fmt
        data blank9/'         '/,blank8/'        '/
        data fmt/'(i4,2x,7(i5,f5.1))'/

        print 2040
 2040 format(////1x,'Program TABLCORN, written by M.O. Hill'/
     1   1x,'May 1992, revised Sep 2011, May 2015'/
     2   1x,'Converts from TABLEFIT format to Cornell ',
     3      'condensed format'//)
        call inout(8,9)

        print 2000,fmt,nitem
        write(9,2000) fmt,nitem
 2000 format('NO TITLE'/a18,50x,i2)
        m=0
        nd=0

   10   continue
        read(8,1000, end=200) sname
        if(sname.eq.blank8) goto 10
        m=m+1
        samp(m)=sname
        print *,sname

        nsp=0
 1000 format(a8)
   30   continue
        short=blank9
        read(8,1001, end=190) short,nq,q
 1001 format(1x,a9,2x,i4,f2.1)
        if(short.eq.blank9) goto 100
        nsp=nsp+1
        call inlist(dict1,ndmax,nd,short,id)
        ispec(nsp)=id
        quant(nsp)=nq+q
        goto 30

  100   continue
        if(nsp.eq.0) then
               write(9,fmt) m
               goto 10
               end if
        call sort2(ispec,quant,nsp)
        nline=(nsp-1)/nitem+1
        do 150 iline=1,nline
                isp1=(iline-1)*nitem+1
                isp2=isp1+nitem-1
                if(isp2.gt.nsp) isp2=nsp
                write(9,fmt) m, (ispec(isp),quant(isp), isp=isp1,isp2)
  150           continue
        goto 10
  190   continue
        if(nsp.eq.0) then
               write(9,fmt) m
               goto 200
               end if
        call sort2(ispec,quant,nsp)
        nline=(nsp-1)/nitem+1
        do 195 iline=1,nline
                isp1=(iline-1)*nitem+1
                isp2=isp1+nitem-1
                if(isp2.gt.nsp) isp2=nsp
                write(9,fmt) m, (ispec(isp),quant(isp), isp=isp1,isp2)
  195           continue
  200   i=0
        write(9,fmt) i
 2002 format(1x,a9)
        do 250 id=1,nd
                short=dict1(id)
                read(short,3002) word1,word2
 3002 format(a4,1x,a4)
                write(sname,3003) word1,word2
 3003 format(2a4)
                dic(id)=sname
  250           continue
        write(9,2001) (dic(id),id=1,nd)
        write(9,2001) (samp(i),i=1,m)
 2001 format(10a8)
        close(8)
        close(9)
        call hold
        stop
        end

      subroutine inlist(dict1,ndmax,nd,short,id)
C Finds the position id of the word short in the list of
C names dict1.  Current length of list is nd.  If short is
C not on the list, it is added and nd is augmented by 1.
      character dict1(ndmax)*9,short*9
      do 10 id=1,nd
      if(dict1(id).eq.short) return
   10 continue
      nd=nd+1
      id=nd
      if(id.gt.ndmax) then
                print 2000,short,ndmax
 2000 format(1x,'Dictionary now full.  Item ',a9, 'Number ',i6)
                stop
      endif
      dict1(nd)=short
      return
      end

      subroutine sort2(ispec,quant,n)
C To order the ispecionary, carrying the types along too

      integer ispec(n),djx,djjx,djjjx
      real quant(n),tjx,tjjx,tjjjx

      do 10 i=1,n
      j=i
      djx=ispec(j)
      tjx=quant(j)
    5 if(j.eq.1) goto 8
      jj=j/2
      djjx=ispec(jj)
      tjjx=quant(jj)
      if(djjx.ge.djx) goto 8
      ispec(j)=djjx
      quant(j)=tjjx
      j=jj
      goto 5
    8 ispec(j)=djx
      quant(j)=tjx
   10 continue
      i=n
      goto 14
   12 ispec(j)=djx
      quant(j)=tjx
   14 if(i.eq.1) return
      djx=ispec(i)
      tjx=quant(i)
      ispec(i)=ispec(1)
      quant(i)=quant(1)
      i=i-1
      j=1
      jj=2
   15 if(i-jj) 12,17,16
   16 djjx=ispec(jj)
      tjjx=quant(jj)
      jjj=jj+1
      djjjx=ispec(jjj)
      tjjjx=quant(jjj)
      if(djjx.ge.djjjx) goto 18
      if(djx.ge.djjjx) goto 12
      ispec(j)=djjjx
      quant(j)=tjjjx
      j=jjj
      jj=j*2
      goto 15
   17 djjx=ispec(jj)
      tjjx=quant(jj)
   18 if(djx.ge.djjx) goto 12
      ispec(j)=djjx
      quant(j)=tjjx
      j=jj
      jj=j*2
      goto 15
      end

      subroutine hold
C Asks for user input before exiting, to retain DOS window
      character*1 ch
      write(*,2000)
 2000 format(////'*** Program finished  ***'///
     1       'Press <RETURN> to exit'///
     2              '*************************')
      read(*,1000) ch
 1000 format(a1)
      return
      end

      subroutine inout(inunit,iout)
C opens inunit for input and iout for output
      character*20 filein,fileout,blank20/'                    '/
      write(*,2062)
 2062 format(//1x,'Enter name of input datafile in TABLEFIT format'/
     1         1x,'     or press <RETURN> for default SAMP.txt')
  100 continue
      read(*,1000) filein
 1000 format(a20)
      if(filein.eq.blank20) then
         open(unit=inunit,file='SAMP.txt',status='old',err=123)
         goto 130
         end if
  122 continue
      open(unit=inunit,file=filein,status='old',err=123)
      goto 130
  123 continue
      write(*,2064)
 2064 format(/'  *** ERROR *** File does not exist'/
     1        ' Type another name')
      read(*,1000) filein
      goto 100
  130 continue
      write(*,2077)
 2077 format(//1x,'Type name of output file (Cornell Condensed)'/
     1         1x,'     or press <RETURN> for default CORNELL.txt')

  205 continue
      read(*,1000) fileout
      if(fileout.eq.blank20) then
         fileout='CORNELL.txt'
         call filogood(fileout,iout)
         goto 220
         end if   
      open(unit=iout,file=fileout,status='new',err=210)
      goto 220
  210 continue
      write(*,2000) fileout
 2000 format(/'  *** ERROR *** File already exists'/
     1        ' Type another name, not ',a20)
      goto 205
 220  continue
      return
      end  

        subroutine filogood(fileout,iunit)
C Finds an output file name based on fileout and adding digits
        character*20 fileout,fileout1,fileout2
        character*1 f1(20),blank1/' '/,dot1/'.'/
        character*1 d(10)/'0','1','2','3','4','5','6','7','8','9'/
        character*1 t/'t'/,x/'x'/
        character*1 w(2)
        character*2 ww
        equivalence(f1,fileout1)
        equivalence(w,ww)
        fileout1=fileout
        fileout2=fileout
        if(f1(1).eq.blank1) f1(1)=t
        do k=1,99
           do i=1,14
              if(f1(i).eq.dot1.or.f1(i).eq.blank1) then
                 ii=i
                 goto 100
                 end if
              ii=14
              enddo
  100      continue
           open(unit=iunit,file=fileout,status='new',err=110)
           return
  110      continue
           if(k.lt.10) then
              f1(ii)=d(1)
              ii=ii+1
              f1(ii)=d(k+1)
              else
              write(ww,2000) k
 2000 format(i2)
              f1(ii)=w(1)
              ii=ii+1
              f1(ii)=w(2)
              end if
           ii=ii+1
           f1(ii)=dot1
           ii=ii+1
           f1(ii)=t
           ii=ii+1
           f1(ii)=x
           ii=ii+1
           f1(ii)=t
           do iii=ii+1,20
              f1(iii)=blank1
              enddo
           fileout=fileout1
           fileout1=fileout2
           enddo
        fileout=fileout2
        return
        end
